#include "coroutine.hpp"
#include "logger.hpp"
#include "net_address.hpp"
#include "reactor.hpp"
#include "tinypb.pb.h"
#include "tinypb_channel.hpp"
#include "tinypb_closure.hpp"
#include "tinypb_controller.hpp"
#include <iostream>
using namespace std;
using namespace tinyrpc;

int n = 100000;

// TcpClient client(NetAddress("127.0.0.1", 9001));


void test1() {
    TinypbChannel channel(NetAddress("127.0.0.1", 9001));
    int n = 10;
    while (n--) {
        logger() << "============== test no:" << n << "===============";

        queryNameReq req_name;
        req_name.set_req_no(20220315);
        req_name.set_id(1100110001);
        req_name.set_type(1);
        queryNameRes res_name;

        queryAgeReq req_age;
        req_age.set_req_no(00001111);
        req_age.set_id(6781);
        queryAgeRes res_age;

        TinypbClosure cb([]() {
            logger() << "==========================";
            logger() << "succ call rpc";
            logger() << "==========================";
        });

        QueryService_Stub stub(&channel);
        TinypbController rpc_controller;
        
        stub.query_name(&rpc_controller, &req_name, &res_name, &cb);
        
        if (rpc_controller.ErrorCode() != 0) {
            logger() << "call rpc method query_name failed, errcode=" << rpc_controller.ErrorCode() << ",error=" << rpc_controller.ErrorText();
        }
        if (res_name.ret_code() != 0) {
            logger() << "query name error, errcode=" << res_name.ret_code() << ", res_info=" << res_name.res_info();
        } else {
            logger() << "get res_name.age = " << res_name.name();
        }
        
    }
}

void test()
{
    
    TinypbChannel channel(NetAddress("127.0.0.1", 9001));
    while (n--) {
        logger() << "============== test no:" << n << "===============";

        queryNameReq req_name;
        req_name.set_req_no(20220315);
        req_name.set_id(1100110001);
        req_name.set_type(1);
        queryNameRes res_name;

        queryAgeReq req_age;
        req_age.set_req_no(00001111);
        req_age.set_id(6781);
        queryAgeRes res_age;

        TinypbClosure cb([]() {
            logger() << "==========================";
            logger() << "succ call rpc";
            logger() << "==========================";
        });

        QueryService_Stub stub(&channel);
        TinypbController rpc_controller;
        
        stub.query_name(&rpc_controller, &req_name, &res_name, &cb);
        
        if (rpc_controller.ErrorCode() != 0) {
            logger() << "call rpc method query_name failed, errcode=" << rpc_controller.ErrorCode() << ",error=" << rpc_controller.ErrorText();
        }
        if (res_name.ret_code() != 0) {
            logger() << "query name error, errcode=" << res_name.ret_code() << ", res_info=" << res_name.res_info();
        } else {
            logger() << "get res_name.age = " << res_name.name();
        }
        
    }
    // test1();
}

int main()
{

    Coroutine cor(test);

    Reactor* reactor = Reactor::getReactor();
    reactor->addCoroutine(cor);
    reactor->loop();

    return 0;
}